#include <stdio.h>
#include "timer.h"

extern FILE *fptr02;

timer *new_timer()
{
   timer *Timer;

   Timer = (timer *) malloc(sizeof(timer));

   return(Timer);
}

void free_timer(timer *Timer)
{
   free(Timer);
}

void timer_reset(timer *Timer)
{
   Timer -> usage_start.ru_stime.tv_sec = 0;
   Timer -> usage_start.ru_stime.tv_usec = 0;
   Timer -> usage_start.ru_utime.tv_sec = 0;
   Timer -> usage_start.ru_utime.tv_usec = 0;

   Timer -> usage_stop.ru_stime.tv_sec = 0;
   Timer -> usage_stop.ru_stime.tv_usec = 0;
   Timer -> usage_stop.ru_utime.tv_sec = 0;
   Timer -> usage_stop.ru_utime.tv_usec = 0;

   Timer -> total_sec = 0;
   Timer -> total_usec = 0;
}

void timer_start(timer *Timer)
{
   getrusage(RUSAGE_SELF, &(Timer -> usage_start));
}

void timer_stop(timer *Timer)
{
   getrusage(RUSAGE_SELF, &(Timer -> usage_stop));
}

void compute_time(timer *Timer)
{
   char          *Subroutine_name = "print_time():";

   struct rusage *usage_start = &(Timer -> usage_start);
   struct rusage *usage_stop = &(Timer -> usage_stop);
   long           user_sec = 0;
   long           user_usec = 0;
   long           sys_sec = 0;
   long           sys_usec = 0;
   long           sec;
   long           usec;

   user_sec  = usage_stop -> ru_utime.tv_sec - usage_start -> ru_utime.tv_sec;
   user_usec = usage_stop -> ru_utime.tv_usec - usage_start -> ru_utime.tv_usec;
   sys_sec   = usage_stop -> ru_stime.tv_sec - usage_start -> ru_stime.tv_sec;
   sys_usec  = usage_stop -> ru_stime.tv_usec - usage_start -> ru_stime.tv_usec;

   if ((user_sec > 0) && (user_usec < 0))
   {
      user_sec--;
      user_usec = (1000000 - usage_start -> ru_utime.tv_usec)
                  + usage_stop -> ru_utime.tv_usec;
   }

   if ((sys_sec > 0) && (sys_usec < 0))
   {
      sys_sec--;
      sys_usec = (1000000 - usage_start -> ru_stime.tv_usec)
                 + usage_stop -> ru_stime.tv_usec;
   }

   sec = user_sec + sys_sec;
   usec = user_usec + sys_usec;

   if (usec >= 1000000)
   {
      sec += usec / 1000000;
      usec = usec % 1000000;
   }

   Timer -> total_sec = sec;
   Timer -> total_usec = usec;

   fprintf(fptr02,"%s %ld sec and %ld usec\n", Subroutine_name,
         Timer -> total_sec, Timer -> total_usec);
}

#if 1
void print_timer(timer *Timer)
{
   char          *Subroutine_name = "print_time():";
   struct rusage *usage_start = &(Timer -> usage_start);
   struct rusage *usage_stop = &(Timer -> usage_stop);

   fprintf(fptr02,"usage_start.user_time: %ld sec %ld usec\n",
         usage_start -> ru_utime.tv_sec, usage_start -> ru_utime.tv_usec);
   fprintf(fptr02,"usage_stop.user_time: %ld sec %ld usec\n",
         usage_stop -> ru_utime.tv_sec, usage_stop -> ru_utime.tv_usec);
   fprintf(fptr02,"usage_start.sys_time: %ld sec %ld usec\n",
         usage_start -> ru_stime.tv_sec, usage_start -> ru_stime.tv_usec);
   fprintf(fptr02,"usage_stop.sys_time: %ld sec %ld usec\n",
         usage_stop -> ru_stime.tv_sec, usage_stop -> ru_stime.tv_usec);

   fprintf(fptr02,"%s %ld sec and %ld usec\n", Subroutine_name,
         Timer -> total_sec, Timer -> total_usec);
}
#endif

